
// kd: This is the Stalin camera's transmission shader. I likened it a bit to an old VHS tape
// recording, which doesn't make much sense, but it certainly looks cool.

// band_t			= 0.5;
// max_x_offset	= 1.04;
// band_size		= 0.08;
// band_x_origin	= 0.3;

void main () {	
	float t				= band_t * (1 + band_size) - (1 - band_t) * band_size;
	float band_total	= 1.0 + band_size;
	
	vec2 sample_pos = TexCoord;
	float abs_dist = abs(sample_pos.y - t);
	
	if(abs_dist < band_size) {
		float band_f = min(1.01 * (band_total - abs_dist), max_x_offset);
		sample_pos.x = band_x_origin + (sample_pos.x - band_x_origin) / band_f;
		sample_pos.y = sample_pos.y - abs_dist;
	}
	
	vec4 color			= texture(InputTexture, sample_pos);
	vec4 color_left		= texture(InputTexture, sample_pos - vec2(0.0035, 0.002));
	vec4 color_right	= texture(InputTexture, sample_pos + vec2(0.0028, 0.0019));
	// vec4 mean_color		= 0.5 * (color_left + color_right);
	// FragColor			= vec4(
		// color.r,
		// (color.g + color_left.b + color_right.g) / 3,
		// (color.b + color_left.g + color_right.b) / 3, 1.0);
	FragColor			= vec4(
		(color.r * 0.6 + 0.2 * color.g + 0.2 * color.b) + 0.13 * color_left.r + 0.13 * color_right.r,
		color_left.g * 0.3 + 0.6 * color.g,
		color_right.b * 0.5 + 0.4 * color.b, 1.0);
}
